//*****************************************************************************
//
// MSP432 main.c template - Empty main
//
//****************************************************************************

#include "msp.h"
#include <stdlib.h>
#include <stdio.h>
#include "uart.h"
#include "Serial_Cmd_Monitor.h"

#define DRDY_BIT    BIT1
#define DRDY_PxIN   P2IN
#define DRDY_PxDIR  P2DIR

int ErrorCount;
unsigned char testArray[32];

void EnterLPMWithWakeupTimer()
{
	/* Enter LPM and wake up periodically based on timer1 */
	__sleep();
}

void InitMSP(void)
{
	/* Stop WDT */
	WDTCTL = WDTPW + WDTHOLD;

	CSKEY = 0x695A;                        // Unlock CS module for register access
	CSCTL0 = 0;                            // Reset tuning parameters
	CSCTL0 = DCORSEL_3;                    // Set DCO to 12MHz (nominal, center of 8-16MHz range)

	// Select ACLK = REFO, SMCLK = MCLK = DCO
	CSCTL1 = SELA_2 | SELS_3 | SELM_3;
	CSKEY = 0;                             // Lock CS module from unintended accesses
}

void PeriodicActions(void)
{
// your code here
	ErrorCount++;
}


void MainExecLoop(void)
{
	while (1)
	{
		/* Enter LPM and wake up periodically every 5 seconds */
		__sleep();

		PeriodicActions();// write temp value to ram
	}
}

void configureTimerWakeUp(void)
{
//    SCB_SCR |= SCB_SCR_SLEEPONEXIT;           // Enable sleep on exit from ISR

    __enable_interrupt();

    NVIC_ISER0 = 1 << ((INT_TA0_0 - 16) & 31);

	TA0CCTL0 &= ~CCIE;
	TA0CCTL0 = CCIE;
	TA0CCTL0 &= ~CCIFG;
	TA0CCTL0 &= ~CCIFG;
	TA0CCR0 = 20480;  //wake up time 5 seconds, Clock Source =  32KHz / 8
	TA0CTL = TASSEL_1 | ID_3 | MC_1 | TACLR;               /* ACLK = REFO, up mode */
}

void Init()
{
	InitMSP();

	uartInit();

	configureTimerWakeUp();

	EnterLPMWithWakeupTimer();

	ClearBufferRelatedParam();
}

//Main program related functions
void main(void)
{
	ErrorCount = 0;
	Init();
	MainExecLoop();
}

void TimerA0_0IsrHandler(void) {
    TA0CCTL0 &= ~CCIFG;
    TA0CCR0 = 20480;
}
